// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS reading value
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSReading}
 */
public final class ESSReading extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSReading)
    ESSReadingOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSReading.newBuilder() to construct.
  private ESSReading(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSReading() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSReading();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReading_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReading_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSReading.class, openfmb.essmodule.ESSReading.Builder.class);
  }

  public static final int CONDUCTINGEQUIPMENTTERMINALREADING_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the conductingEquipmentTerminalReading field is set.
   */
  @java.lang.Override
  public boolean hasConductingEquipmentTerminalReading() {
    return conductingEquipmentTerminalReading_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
   * @return The conductingEquipmentTerminalReading.
   */
  @java.lang.Override
  public openfmb.commonmodule.ConductingEquipmentTerminalReading getConductingEquipmentTerminalReading() {
    return conductingEquipmentTerminalReading_ == null ? openfmb.commonmodule.ConductingEquipmentTerminalReading.getDefaultInstance() : conductingEquipmentTerminalReading_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ConductingEquipmentTerminalReadingOrBuilder getConductingEquipmentTerminalReadingOrBuilder() {
    return conductingEquipmentTerminalReading_ == null ? openfmb.commonmodule.ConductingEquipmentTerminalReading.getDefaultInstance() : conductingEquipmentTerminalReading_;
  }

  public static final int PHASEMMTN_FIELD_NUMBER = 2;
  private openfmb.commonmodule.PhaseMMTN phaseMMTN_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
   * @return Whether the phaseMMTN field is set.
   */
  @java.lang.Override
  public boolean hasPhaseMMTN() {
    return phaseMMTN_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
   * @return The phaseMMTN.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseMMTN getPhaseMMTN() {
    return phaseMMTN_ == null ? openfmb.commonmodule.PhaseMMTN.getDefaultInstance() : phaseMMTN_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseMMTNOrBuilder getPhaseMMTNOrBuilder() {
    return phaseMMTN_ == null ? openfmb.commonmodule.PhaseMMTN.getDefaultInstance() : phaseMMTN_;
  }

  public static final int READINGMMTR_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ReadingMMTR readingMMTR_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
   * @return Whether the readingMMTR field is set.
   */
  @java.lang.Override
  public boolean hasReadingMMTR() {
    return readingMMTR_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
   * @return The readingMMTR.
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMMTR getReadingMMTR() {
    return readingMMTR_ == null ? openfmb.commonmodule.ReadingMMTR.getDefaultInstance() : readingMMTR_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMMTROrBuilder getReadingMMTROrBuilder() {
    return readingMMTR_ == null ? openfmb.commonmodule.ReadingMMTR.getDefaultInstance() : readingMMTR_;
  }

  public static final int READINGMMXU_FIELD_NUMBER = 4;
  private openfmb.commonmodule.ReadingMMXU readingMMXU_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
   * @return Whether the readingMMXU field is set.
   */
  @java.lang.Override
  public boolean hasReadingMMXU() {
    return readingMMXU_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
   * @return The readingMMXU.
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMMXU getReadingMMXU() {
    return readingMMXU_ == null ? openfmb.commonmodule.ReadingMMXU.getDefaultInstance() : readingMMXU_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMMXUOrBuilder getReadingMMXUOrBuilder() {
    return readingMMXU_ == null ? openfmb.commonmodule.ReadingMMXU.getDefaultInstance() : readingMMXU_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (conductingEquipmentTerminalReading_ != null) {
      output.writeMessage(1, getConductingEquipmentTerminalReading());
    }
    if (phaseMMTN_ != null) {
      output.writeMessage(2, getPhaseMMTN());
    }
    if (readingMMTR_ != null) {
      output.writeMessage(3, getReadingMMTR());
    }
    if (readingMMXU_ != null) {
      output.writeMessage(4, getReadingMMXU());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (conductingEquipmentTerminalReading_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getConductingEquipmentTerminalReading());
    }
    if (phaseMMTN_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPhaseMMTN());
    }
    if (readingMMTR_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getReadingMMTR());
    }
    if (readingMMXU_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getReadingMMXU());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSReading)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSReading other = (openfmb.essmodule.ESSReading) obj;

    if (hasConductingEquipmentTerminalReading() != other.hasConductingEquipmentTerminalReading()) return false;
    if (hasConductingEquipmentTerminalReading()) {
      if (!getConductingEquipmentTerminalReading()
          .equals(other.getConductingEquipmentTerminalReading())) return false;
    }
    if (hasPhaseMMTN() != other.hasPhaseMMTN()) return false;
    if (hasPhaseMMTN()) {
      if (!getPhaseMMTN()
          .equals(other.getPhaseMMTN())) return false;
    }
    if (hasReadingMMTR() != other.hasReadingMMTR()) return false;
    if (hasReadingMMTR()) {
      if (!getReadingMMTR()
          .equals(other.getReadingMMTR())) return false;
    }
    if (hasReadingMMXU() != other.hasReadingMMXU()) return false;
    if (hasReadingMMXU()) {
      if (!getReadingMMXU()
          .equals(other.getReadingMMXU())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasConductingEquipmentTerminalReading()) {
      hash = (37 * hash) + CONDUCTINGEQUIPMENTTERMINALREADING_FIELD_NUMBER;
      hash = (53 * hash) + getConductingEquipmentTerminalReading().hashCode();
    }
    if (hasPhaseMMTN()) {
      hash = (37 * hash) + PHASEMMTN_FIELD_NUMBER;
      hash = (53 * hash) + getPhaseMMTN().hashCode();
    }
    if (hasReadingMMTR()) {
      hash = (37 * hash) + READINGMMTR_FIELD_NUMBER;
      hash = (53 * hash) + getReadingMMTR().hashCode();
    }
    if (hasReadingMMXU()) {
      hash = (37 * hash) + READINGMMXU_FIELD_NUMBER;
      hash = (53 * hash) + getReadingMMXU().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSReading parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReading parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReading parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReading parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReading parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReading parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSReading prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS reading value
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSReading}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSReading)
      openfmb.essmodule.ESSReadingOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReading_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReading_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSReading.class, openfmb.essmodule.ESSReading.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSReading.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      conductingEquipmentTerminalReading_ = null;
      if (conductingEquipmentTerminalReadingBuilder_ != null) {
        conductingEquipmentTerminalReadingBuilder_.dispose();
        conductingEquipmentTerminalReadingBuilder_ = null;
      }
      phaseMMTN_ = null;
      if (phaseMMTNBuilder_ != null) {
        phaseMMTNBuilder_.dispose();
        phaseMMTNBuilder_ = null;
      }
      readingMMTR_ = null;
      if (readingMMTRBuilder_ != null) {
        readingMMTRBuilder_.dispose();
        readingMMTRBuilder_ = null;
      }
      readingMMXU_ = null;
      if (readingMMXUBuilder_ != null) {
        readingMMXUBuilder_.dispose();
        readingMMXUBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReading_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReading getDefaultInstanceForType() {
      return openfmb.essmodule.ESSReading.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReading build() {
      openfmb.essmodule.ESSReading result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReading buildPartial() {
      openfmb.essmodule.ESSReading result = new openfmb.essmodule.ESSReading(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSReading result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.conductingEquipmentTerminalReading_ = conductingEquipmentTerminalReadingBuilder_ == null
            ? conductingEquipmentTerminalReading_
            : conductingEquipmentTerminalReadingBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.phaseMMTN_ = phaseMMTNBuilder_ == null
            ? phaseMMTN_
            : phaseMMTNBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.readingMMTR_ = readingMMTRBuilder_ == null
            ? readingMMTR_
            : readingMMTRBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.readingMMXU_ = readingMMXUBuilder_ == null
            ? readingMMXU_
            : readingMMXUBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSReading) {
        return mergeFrom((openfmb.essmodule.ESSReading)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSReading other) {
      if (other == openfmb.essmodule.ESSReading.getDefaultInstance()) return this;
      if (other.hasConductingEquipmentTerminalReading()) {
        mergeConductingEquipmentTerminalReading(other.getConductingEquipmentTerminalReading());
      }
      if (other.hasPhaseMMTN()) {
        mergePhaseMMTN(other.getPhaseMMTN());
      }
      if (other.hasReadingMMTR()) {
        mergeReadingMMTR(other.getReadingMMTR());
      }
      if (other.hasReadingMMXU()) {
        mergeReadingMMXU(other.getReadingMMXU());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getConductingEquipmentTerminalReadingFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPhaseMMTNFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getReadingMMTRFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getReadingMMXUFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ConductingEquipmentTerminalReading, openfmb.commonmodule.ConductingEquipmentTerminalReading.Builder, openfmb.commonmodule.ConductingEquipmentTerminalReadingOrBuilder> conductingEquipmentTerminalReadingBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the conductingEquipmentTerminalReading field is set.
     */
    public boolean hasConductingEquipmentTerminalReading() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     * @return The conductingEquipmentTerminalReading.
     */
    public openfmb.commonmodule.ConductingEquipmentTerminalReading getConductingEquipmentTerminalReading() {
      if (conductingEquipmentTerminalReadingBuilder_ == null) {
        return conductingEquipmentTerminalReading_ == null ? openfmb.commonmodule.ConductingEquipmentTerminalReading.getDefaultInstance() : conductingEquipmentTerminalReading_;
      } else {
        return conductingEquipmentTerminalReadingBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setConductingEquipmentTerminalReading(openfmb.commonmodule.ConductingEquipmentTerminalReading value) {
      if (conductingEquipmentTerminalReadingBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        conductingEquipmentTerminalReading_ = value;
      } else {
        conductingEquipmentTerminalReadingBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setConductingEquipmentTerminalReading(
        openfmb.commonmodule.ConductingEquipmentTerminalReading.Builder builderForValue) {
      if (conductingEquipmentTerminalReadingBuilder_ == null) {
        conductingEquipmentTerminalReading_ = builderForValue.build();
      } else {
        conductingEquipmentTerminalReadingBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeConductingEquipmentTerminalReading(openfmb.commonmodule.ConductingEquipmentTerminalReading value) {
      if (conductingEquipmentTerminalReadingBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          conductingEquipmentTerminalReading_ != null &&
          conductingEquipmentTerminalReading_ != openfmb.commonmodule.ConductingEquipmentTerminalReading.getDefaultInstance()) {
          getConductingEquipmentTerminalReadingBuilder().mergeFrom(value);
        } else {
          conductingEquipmentTerminalReading_ = value;
        }
      } else {
        conductingEquipmentTerminalReadingBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearConductingEquipmentTerminalReading() {
      bitField0_ = (bitField0_ & ~0x00000001);
      conductingEquipmentTerminalReading_ = null;
      if (conductingEquipmentTerminalReadingBuilder_ != null) {
        conductingEquipmentTerminalReadingBuilder_.dispose();
        conductingEquipmentTerminalReadingBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ConductingEquipmentTerminalReading.Builder getConductingEquipmentTerminalReadingBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getConductingEquipmentTerminalReadingFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ConductingEquipmentTerminalReadingOrBuilder getConductingEquipmentTerminalReadingOrBuilder() {
      if (conductingEquipmentTerminalReadingBuilder_ != null) {
        return conductingEquipmentTerminalReadingBuilder_.getMessageOrBuilder();
      } else {
        return conductingEquipmentTerminalReading_ == null ?
            openfmb.commonmodule.ConductingEquipmentTerminalReading.getDefaultInstance() : conductingEquipmentTerminalReading_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipmentTerminalReading conductingEquipmentTerminalReading = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ConductingEquipmentTerminalReading, openfmb.commonmodule.ConductingEquipmentTerminalReading.Builder, openfmb.commonmodule.ConductingEquipmentTerminalReadingOrBuilder> 
        getConductingEquipmentTerminalReadingFieldBuilder() {
      if (conductingEquipmentTerminalReadingBuilder_ == null) {
        conductingEquipmentTerminalReadingBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ConductingEquipmentTerminalReading, openfmb.commonmodule.ConductingEquipmentTerminalReading.Builder, openfmb.commonmodule.ConductingEquipmentTerminalReadingOrBuilder>(
                getConductingEquipmentTerminalReading(),
                getParentForChildren(),
                isClean());
        conductingEquipmentTerminalReading_ = null;
      }
      return conductingEquipmentTerminalReadingBuilder_;
    }

    private openfmb.commonmodule.PhaseMMTN phaseMMTN_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseMMTN, openfmb.commonmodule.PhaseMMTN.Builder, openfmb.commonmodule.PhaseMMTNOrBuilder> phaseMMTNBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     * @return Whether the phaseMMTN field is set.
     */
    public boolean hasPhaseMMTN() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     * @return The phaseMMTN.
     */
    public openfmb.commonmodule.PhaseMMTN getPhaseMMTN() {
      if (phaseMMTNBuilder_ == null) {
        return phaseMMTN_ == null ? openfmb.commonmodule.PhaseMMTN.getDefaultInstance() : phaseMMTN_;
      } else {
        return phaseMMTNBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public Builder setPhaseMMTN(openfmb.commonmodule.PhaseMMTN value) {
      if (phaseMMTNBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phaseMMTN_ = value;
      } else {
        phaseMMTNBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public Builder setPhaseMMTN(
        openfmb.commonmodule.PhaseMMTN.Builder builderForValue) {
      if (phaseMMTNBuilder_ == null) {
        phaseMMTN_ = builderForValue.build();
      } else {
        phaseMMTNBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public Builder mergePhaseMMTN(openfmb.commonmodule.PhaseMMTN value) {
      if (phaseMMTNBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          phaseMMTN_ != null &&
          phaseMMTN_ != openfmb.commonmodule.PhaseMMTN.getDefaultInstance()) {
          getPhaseMMTNBuilder().mergeFrom(value);
        } else {
          phaseMMTN_ = value;
        }
      } else {
        phaseMMTNBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public Builder clearPhaseMMTN() {
      bitField0_ = (bitField0_ & ~0x00000002);
      phaseMMTN_ = null;
      if (phaseMMTNBuilder_ != null) {
        phaseMMTNBuilder_.dispose();
        phaseMMTNBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public openfmb.commonmodule.PhaseMMTN.Builder getPhaseMMTNBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPhaseMMTNFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    public openfmb.commonmodule.PhaseMMTNOrBuilder getPhaseMMTNOrBuilder() {
      if (phaseMMTNBuilder_ != null) {
        return phaseMMTNBuilder_.getMessageOrBuilder();
      } else {
        return phaseMMTN_ == null ?
            openfmb.commonmodule.PhaseMMTN.getDefaultInstance() : phaseMMTN_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.PhaseMMTN phaseMMTN = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseMMTN, openfmb.commonmodule.PhaseMMTN.Builder, openfmb.commonmodule.PhaseMMTNOrBuilder> 
        getPhaseMMTNFieldBuilder() {
      if (phaseMMTNBuilder_ == null) {
        phaseMMTNBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseMMTN, openfmb.commonmodule.PhaseMMTN.Builder, openfmb.commonmodule.PhaseMMTNOrBuilder>(
                getPhaseMMTN(),
                getParentForChildren(),
                isClean());
        phaseMMTN_ = null;
      }
      return phaseMMTNBuilder_;
    }

    private openfmb.commonmodule.ReadingMMTR readingMMTR_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMMTR, openfmb.commonmodule.ReadingMMTR.Builder, openfmb.commonmodule.ReadingMMTROrBuilder> readingMMTRBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     * @return Whether the readingMMTR field is set.
     */
    public boolean hasReadingMMTR() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     * @return The readingMMTR.
     */
    public openfmb.commonmodule.ReadingMMTR getReadingMMTR() {
      if (readingMMTRBuilder_ == null) {
        return readingMMTR_ == null ? openfmb.commonmodule.ReadingMMTR.getDefaultInstance() : readingMMTR_;
      } else {
        return readingMMTRBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public Builder setReadingMMTR(openfmb.commonmodule.ReadingMMTR value) {
      if (readingMMTRBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        readingMMTR_ = value;
      } else {
        readingMMTRBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public Builder setReadingMMTR(
        openfmb.commonmodule.ReadingMMTR.Builder builderForValue) {
      if (readingMMTRBuilder_ == null) {
        readingMMTR_ = builderForValue.build();
      } else {
        readingMMTRBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public Builder mergeReadingMMTR(openfmb.commonmodule.ReadingMMTR value) {
      if (readingMMTRBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          readingMMTR_ != null &&
          readingMMTR_ != openfmb.commonmodule.ReadingMMTR.getDefaultInstance()) {
          getReadingMMTRBuilder().mergeFrom(value);
        } else {
          readingMMTR_ = value;
        }
      } else {
        readingMMTRBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public Builder clearReadingMMTR() {
      bitField0_ = (bitField0_ & ~0x00000004);
      readingMMTR_ = null;
      if (readingMMTRBuilder_ != null) {
        readingMMTRBuilder_.dispose();
        readingMMTRBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public openfmb.commonmodule.ReadingMMTR.Builder getReadingMMTRBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getReadingMMTRFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    public openfmb.commonmodule.ReadingMMTROrBuilder getReadingMMTROrBuilder() {
      if (readingMMTRBuilder_ != null) {
        return readingMMTRBuilder_.getMessageOrBuilder();
      } else {
        return readingMMTR_ == null ?
            openfmb.commonmodule.ReadingMMTR.getDefaultInstance() : readingMMTR_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMTR readingMMTR = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMMTR, openfmb.commonmodule.ReadingMMTR.Builder, openfmb.commonmodule.ReadingMMTROrBuilder> 
        getReadingMMTRFieldBuilder() {
      if (readingMMTRBuilder_ == null) {
        readingMMTRBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ReadingMMTR, openfmb.commonmodule.ReadingMMTR.Builder, openfmb.commonmodule.ReadingMMTROrBuilder>(
                getReadingMMTR(),
                getParentForChildren(),
                isClean());
        readingMMTR_ = null;
      }
      return readingMMTRBuilder_;
    }

    private openfmb.commonmodule.ReadingMMXU readingMMXU_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMMXU, openfmb.commonmodule.ReadingMMXU.Builder, openfmb.commonmodule.ReadingMMXUOrBuilder> readingMMXUBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     * @return Whether the readingMMXU field is set.
     */
    public boolean hasReadingMMXU() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     * @return The readingMMXU.
     */
    public openfmb.commonmodule.ReadingMMXU getReadingMMXU() {
      if (readingMMXUBuilder_ == null) {
        return readingMMXU_ == null ? openfmb.commonmodule.ReadingMMXU.getDefaultInstance() : readingMMXU_;
      } else {
        return readingMMXUBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public Builder setReadingMMXU(openfmb.commonmodule.ReadingMMXU value) {
      if (readingMMXUBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        readingMMXU_ = value;
      } else {
        readingMMXUBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public Builder setReadingMMXU(
        openfmb.commonmodule.ReadingMMXU.Builder builderForValue) {
      if (readingMMXUBuilder_ == null) {
        readingMMXU_ = builderForValue.build();
      } else {
        readingMMXUBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public Builder mergeReadingMMXU(openfmb.commonmodule.ReadingMMXU value) {
      if (readingMMXUBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          readingMMXU_ != null &&
          readingMMXU_ != openfmb.commonmodule.ReadingMMXU.getDefaultInstance()) {
          getReadingMMXUBuilder().mergeFrom(value);
        } else {
          readingMMXU_ = value;
        }
      } else {
        readingMMXUBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public Builder clearReadingMMXU() {
      bitField0_ = (bitField0_ & ~0x00000008);
      readingMMXU_ = null;
      if (readingMMXUBuilder_ != null) {
        readingMMXUBuilder_.dispose();
        readingMMXUBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public openfmb.commonmodule.ReadingMMXU.Builder getReadingMMXUBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getReadingMMXUFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    public openfmb.commonmodule.ReadingMMXUOrBuilder getReadingMMXUOrBuilder() {
      if (readingMMXUBuilder_ != null) {
        return readingMMXUBuilder_.getMessageOrBuilder();
      } else {
        return readingMMXU_ == null ?
            openfmb.commonmodule.ReadingMMXU.getDefaultInstance() : readingMMXU_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ReadingMMXU readingMMXU = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMMXU, openfmb.commonmodule.ReadingMMXU.Builder, openfmb.commonmodule.ReadingMMXUOrBuilder> 
        getReadingMMXUFieldBuilder() {
      if (readingMMXUBuilder_ == null) {
        readingMMXUBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ReadingMMXU, openfmb.commonmodule.ReadingMMXU.Builder, openfmb.commonmodule.ReadingMMXUOrBuilder>(
                getReadingMMXU(),
                getParentForChildren(),
                isClean());
        readingMMXU_ = null;
      }
      return readingMMXUBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSReading)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSReading)
  private static final openfmb.essmodule.ESSReading DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSReading();
  }

  public static openfmb.essmodule.ESSReading getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSReading>
      PARSER = new com.google.protobuf.AbstractParser<ESSReading>() {
    @java.lang.Override
    public ESSReading parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSReading> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSReading> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSReading getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

